#include <i86.h>
#include "def.h"

void pds_dpmi_dos_freemem()
{
struct dosmem_t *dm=&dosmem_t;
 union REGS regs;
 if(dm->selector){
  memset(&regs,0,sizeof(union REGS));
  regs.w.ax = 0x0101;
  regs.w.dx = dm->selector;
  int386(0x31, &regs, &regs);
  dm->selector=dm->segment=0;
  dm->linearptr=NULL;
 }
}

struct dosmem_t *pds_dpmi_dos_allocmem(unsigned int size)
{
struct dosmem_t *dm=&dosmem_t;
 union REGS regs;
 if(dm->selector) pds_dpmi_dos_freemem();
 memset(&regs,0,sizeof(union REGS));
 regs.w.ax = 0x0100;
 regs.w.bx = (unsigned short) (size+15)>>4;
 int386(0x31,&regs,&regs);
 if(regs.w.cflag)  return NULL;
 dm->selector=(unsigned short)regs.w.dx;
 dm->segment=(unsigned short)regs.w.ax;
 dm->linearptr=(void *)(regs.w.ax<<4);
 memset(dm->linearptr,0,size);
 return dm;
}

unsigned long pds_dpmi_map_physical_memory(unsigned long phys_addr,unsigned long memsize)
{
 union REGS regs;
 memset(&regs,0,sizeof(union REGS));
 regs.w.ax=0x0800;
 regs.w.bx=(phys_addr>>16);
 regs.w.cx=(phys_addr&0xffff);
 regs.w.di=(memsize&0xffff);
 regs.w.si=(memsize>>16);
 int386(0x31,&regs,&regs);
 if(regs.w.cflag)  return 0;
 return ((regs.x.ebx<<16)|(regs.x.ecx&0xffff));
}

void pds_dpmi_unmap_physycal_memory(unsigned long linear_addr)
{
 union REGS regs;
 if(!linear_addr)  return;
 memset(&regs,0,sizeof(union REGS));
 regs.w.ax=0x0801;
 regs.w.bx=linear_addr>>16;
 regs.w.cx=linear_addr&0xffff;
 int386(0x31,&regs,&regs);
}
