#include "def.h"

unsigned int MDma_get_max_pcmoutbufsize(unsigned int max_bufsize,unsigned int pagesize,unsigned int samplesize,unsigned long freq_config)
{
 unsigned int bufsize;
 if(!max_bufsize)  max_bufsize=AUCARDS_DMABUFSIZE_MAX;
 if(!pagesize)     pagesize=AUCARDS_DMABUFSIZE_BLOCK;
 if(samplesize<2)  samplesize=2;
 bufsize=AUCARDS_DMABUFSIZE_NORMAL/2; // samplesize/=2;

 if(freq_config)  bufsize=(int)((float)bufsize*(float)freq_config/44100.0);

 bufsize*=samplesize;          // 2x bufsize at 32-bit output (1.5x at 24)
 bufsize+=(pagesize-1);        // rounding up to pagesize
 bufsize-=(bufsize%pagesize);  //
 if(bufsize>max_bufsize)  bufsize=max_bufsize-(max_bufsize%pagesize);
 return bufsize;
}

unsigned int MDma_init_pcmoutbuf(struct mpxplay_audioout_info_s *aui,unsigned int maxbufsize,unsigned int pagesize,unsigned long freq_config)
{
 unsigned int dmabufsize,bit_width,tmp;
 float freq;

 freq=(freq_config)? freq_config:44100;
 switch(aui->card_wave_id){
  case MPXPLAY_WAVEID_PCM_FLOAT:bit_width=32;break;
  default:bit_width=aui->bits_card;break;
 }

 dmabufsize=(unsigned int)((float)maxbufsize*(float)aui->freq_card/freq);
					// *(float)bit_width/16.0);
 dmabufsize+=(pagesize-1);		// rounding up to pagesize
 dmabufsize-=(dmabufsize%pagesize);	//
 if(dmabufsize<(pagesize*2))  dmabufsize=(pagesize*2);
 if(dmabufsize>maxbufsize){
	dmabufsize=maxbufsize;
	dmabufsize-=(dmabufsize%pagesize);
	}

 funcbit_smp_value_put(aui->card_bytespersign,aui->chan_card*((bit_width+7)/8));
 funcbit_smp_value_put(aui->card_dmasize,dmabufsize);
/*
 if(!aui->card_outbytes)
  funcbit_smp_value_put(aui->card_outbytes,PCM_OUTSAMPLES*aui->card_bytespersign); // not exact

 tmp=(long) ( (float)aui->freq_card*(float)aui->card_bytespersign
   /((float)INT08_DIVISOR_DEFAULT*(float)INT08_CYCLES_DEFAULT/(float)INT08_DIVISOR_NEW) );

 tmp+=aui->card_bytespersign-1;                              // rounding up
 tmp-=(aui->card_dmaout_under_int08%aui->card_bytespersign); // to pcm_samples
 funcbit_smp_value_put(aui->card_dmaout_under_int08,tmp);
*/
 funcbit_smp_value_put(aui->card_dma_lastgoodpos,0); // !!! the soundcard also must to do this
 tmp =aui->card_dmasize/2;
 tmp-=aui->card_dmalastput%aui->card_bytespersign; // round down to pcm_samples
 funcbit_smp_value_put(aui->card_dmalastput,tmp);
 funcbit_smp_value_put(aui->card_dmafilled,aui->card_dmalastput);
 funcbit_smp_value_put(aui->card_dmaspace,aui->card_dmasize-aui->card_dmafilled);
/*
 freq=(aui->freq_song<22050)? 22050.0:(float)aui->freq_song;
 funcbit_smp_value_put(aui->int08_decoder_cycles,(long)(freq/(float)PCM_OUTSAMPLES)*(float)INT08_DIVISOR_NEW/(float)(INT08_CYCLES_DEFAULT*INT08_DIVISOR_DEFAULT)+1);
*/
 return dmabufsize;
}

void MDma_clearbuf(struct mpxplay_audioout_info_s *aui)
{
 if(aui->card_DMABUFF && aui->card_dmasize)
  memset(aui->card_DMABUFF,0,aui->card_dmasize);
}

void MDma_writedata(struct mpxplay_audioout_info_s *aui,char *src,unsigned long left)
{
 unsigned int todo=aui->card_dmasize-aui->card_dmalastput;

 if(todo<=left){
  memcpy(aui->card_DMABUFF+aui->card_dmalastput,src,todo);
  aui->card_dmalastput=0;
  left-=todo;
  src+=todo;
 }
 if(left){
  memcpy(aui->card_DMABUFF+aui->card_dmalastput,src,left);
  aui->card_dmalastput+=left;
 }
}
/*
// *************** called from int08 **********************************
// checks the DMA buffer and if it's empty, fills with zeroes
void MDma_interrupt_monitor(struct mpxplay_audioout_info_s *aui)
{
 if(aui->card_dmafilled<(aui->card_dmaout_under_int08*2)){
  if(!(aui->card_infobits&AUINFOS_CARDINFOBIT_DMAUNDERRUN)){
   MDma_clearbuf(aui);
   funcbit_smp_enable(aui->card_infobits,AUINFOS_CARDINFOBIT_DMAUNDERRUN);
  }
 }else{
  aui->card_dmafilled-=aui->card_dmaout_under_int08;
  funcbit_smp_disable(aui->card_infobits,AUINFOS_CARDINFOBIT_DMAUNDERRUN);
 }
}
*/
